'From VisualWorks®, Pre-Release 7.5.1 (nov07.3) of November 18, 2007 on January 25, 2008 at 2:30:31 pm'!
"Package SeasideErrorNotifier(2,store)="!


CodeComponent type: #package named: 'SeasideErrorNotifier' property: #developmentPrerequisites value: #(#(#any 'Mail' '') #(#any 'Seaside' '') #(#any 'Seaside-Preload' '') #(#any 'SMTP' '') #(#any 'BaseExtensions' '') #(#any 'MIME' '') #(#any 'NetClientBase' '') #(#any 'Squeak-Extensions' ''))!

CodeComponent type: #package named: 'SeasideErrorNotifier' property: #prerequisiteParcels value: #(#('Mail' '') #('Seaside' '') #('Seaside-Preload' '') #('SMTP' '') #('BaseExtensions' '') #('MIME' '') #('NetClientBase' '') #('Squeak-Extensions' ''))!

Smalltalk defineNameSpace: #SeasideErrorNotifier
	private: false
	imports: '
			private Smalltalk.*
			private Seaside.*
			'
	category: 'My Classes'!

Smalltalk.SeasideErrorNotifier defineClass: #NotifyingErrorHandlerConfiguration
	superclass: #{Seaside.WASystemConfiguration}
	indexedType: #none
	private: false
	instanceVariableNames: ''
	classInstanceVariableNames: ''
	imports: ''
	category: 'My Classes'!

Smalltalk.SeasideErrorNotifier defineClass: #NotifyingErrorHandler
	superclass: #{Seaside.WAErrorHandler}
	indexedType: #none
	private: false
	instanceVariableNames: ''
	classInstanceVariableNames: ''
	imports: ''
	category: 'My Classes'!




!SeasideErrorNotifier.NotifyingErrorHandlerConfiguration methodsFor: 'ancestry'!

ancestors
	^Array with: WARenderLoopConfiguration new! !

!SeasideErrorNotifier.NotifyingErrorHandlerConfiguration methodsFor: 'attributes'!

attributes
	^Array
		with:
			(WAStringAttribute key: #errorNotificationRecipients group: #errorNotifier)
		with:
			(WAStringAttribute key: #errorNotificationSMTPServer group: #errorNotifier)! !

!SeasideErrorNotifier.NotifyingErrorHandlerConfiguration methodsFor: 'defaults'!

errorNotificationSMTPServer
	^'localhost'!

errorHandler
	^NotifyingErrorHandler! !


!SeasideErrorNotifier.NotifyingErrorHandler methodsFor: 'private'!

sendErrorNotification: anError
	| recipients server message |
	recipients := self application preferenceAt: #errorNotificationRecipients.
	server := self application preferenceAt: #errorNotificationSMTPServer.
	(recipients pruned isNil or: [server pruned isNil]) ifTrue: [^self].
	message := Net.MailMessage newTextPlain.
	message
		from: 'no-reply@miriamtech.com';
		to: recipients.
	message
		subject:
			('[<1s>]: <2s>'
				expandMacrosWith: self application name
				with: anError messageText).
	message
		text:
			(String
				streamContents:
					[:ws | 
					(SeasidePlatformSupport walkbackStringsFor: anError)
						do:
							[:each | 
							ws
								nextPutAll: each;
								cr]]).
	(Net.SMTPClient connectToHost: server port: 25)
		useAuthentication: false;
		send: message!

session
	^WACurrentSession value!

application
	^self session application! !

!SeasideErrorNotifier.NotifyingErrorHandler methodsFor: 'actions'!

handleError: anError
	self application deploymentMode
		ifFalse: [^WAWalkbackErrorHandler new handleError: anError].
	[self sendErrorNotification: anError] on: Error do: [:ex | nil].
	self session returnResponse: (WAResponse internalError: anError)! !


